from _typeshed import Incomplete
from io import RawIOBase
from pyftdi.ftdi import Ftdi as Ftdi
from pyftdi.usbtools import UsbToolsError as UsbToolsError
from serial import SerialBase

class FtdiSerial(SerialBase):
    BAUDRATES: Incomplete
    PYSERIAL_VERSION: Incomplete
    udev: Incomplete
    def open(self) -> None: ...
    def close(self) -> None: ...
    def read(self, size: int = ...): ...
    def write(self, data): ...
    def flush(self) -> None: ...
    def reset_input_buffer(self) -> None: ...
    def reset_output_buffer(self) -> None: ...
    def send_break(self, duration: float = ...) -> None: ...
    @property
    def ftdi(self) -> Ftdi: ...
    @property
    def usb_path(self): ...
    @property
    def cts(self): ...
    @property
    def dsr(self): ...
    @property
    def ri(self): ...
    @property
    def cd(self): ...
    @property
    def in_waiting(self): ...
    @property
    def out_waiting(self): ...
    @property
    def fifoSizes(self): ...

class Serial(FtdiSerial, RawIOBase):
    BACKEND: str
    def __init__(self, *args, **kwargs) -> None: ...
